//
//  MediaData.m
//  Movies
//
//  Created by Steve Zaharuk on 5/6/13.
//  Copyright (c) 2013 com.infragistics. All rights reserved.
//

#import "MediaData.h"

@implementation MediaData
+(NSMutableArray*)generateData
{
    NSMutableDictionary* mediaLookup = [[NSMutableDictionary alloc]init];
    NSMutableArray* netFlixData = [[NSMutableArray alloc]init];
    
    NSString* rootUrl = @"https://itunes.apple.com/search?term=%@&media=movie&entity=movie&limit=600&attribute=releaseYearTerm";
    
    NSArray* keys = @[@"2012", @"2013"];
    
    for(NSString* key in keys)
    {
        NSURL* url = [NSURL URLWithString:[NSString stringWithFormat:rootUrl, key]];
        
        NSData* data = [NSData dataWithContentsOfURL:url];
        NSDictionary* json = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:nil];
        NSArray* results = [json valueForKey:@"results"];
        
        if(results != nil)
        {
            for(NSDictionary* mediaInfo in results)
            {
                NSString* genre = [NSString stringWithFormat:@"%@", [mediaInfo valueForKey:@"primaryGenreName"]];
                NSString* url = [mediaInfo valueForKey:@"artworkUrl100"];
                
                MediaItem* media = [[MediaItem alloc]init];
                media.title = [mediaInfo valueForKey:@"trackName"];
                media.imgUrl = [NSURL URLWithString:url];
                
                MediaData* nfd = [mediaLookup valueForKey:genre];
                if(nfd == nil)
                {
                    nfd = [[MediaData alloc]init];
                    nfd.genre = genre;
                    nfd.media = [[NSMutableArray alloc]init];
                    [mediaLookup setValue:nfd forKey:genre];
                    [netFlixData addObject:nfd];
                }
                
                [nfd.media addObject:media];
            }
            
        }
    }
    
    
    return netFlixData;
    
    
}

@end

@implementation MediaItem

@end

