//
//  ViewController.m
//  Movies
//
//  Created by Steve Zaharuk on 5/6/13.
//  Copyright (c) 2013 com.infragistics. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    _gridView = [[IGGridView alloc]initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height)];
    _gridView.autoresizingMask = UIViewAutoresizingFlexibleHeight |UIViewAutoresizingFlexibleWidth;
    [self.view addSubview:_gridView];
    
    _gridView.rowHeight = 200;
    _gridView.headerHeight = 0;
    _gridView.backgroundColor = [UIColor blackColor];
    _gridView.selectionType = IGGridViewSelectionTypeNone;
    
    _ds = [[IGGridViewDataSourceHelper alloc]init];
    _ds.autoGenerateColumns = NO;
    
    [_ds.columnDefinitions addObject:[[MediaColumnDefinition alloc]initWithKey:@"media"]];
    
    _ds.groupingKey = @"genre";
    _ds.data = [MediaData generateData];
    
    _gridView.dataSource = _ds;
    
}

@end

@implementation MediaColumnDefinition

-(IGGridViewCell *)gridView:(IGGridView *)gridView createCell:(IGCellPath *)path usingDataSource:(IGGridViewDataSourceHelper *)dataSource
{
    MediaData* data = [dataSource resolveDataObjectForRow:path];
    
    MediaCell* cell = [gridView dequeueReusableCellWithIdentifier:@"MEDIA_CELL"];
    if(cell == nil)
        cell = [[MediaCell alloc]initWithReuseIdentifier:@"MEDIA_CELL"];
    
    cell.data = data;
    
    return cell;
}

@end

@implementation MediaCell

-(id)init
{
    self = [super init];
    if(self)
    {
        _gridView = [[IGGridView alloc]init];
        _gridView.allowHorizontalBounce = YES;
        _gridView.alwaysBounceVertical = NO;
        _gridView.alwaysBounceHorizontal = YES;
        _gridView.headerHeight = 0;
        _gridView.rowSeparatorHeight = 0;
        _gridView.rowHeight = 200;
        _gridView.columnWidth = [[IGColumnWidth alloc]initWithWidth:150];
        _gridView.selectionType = IGGridViewSelectionTypeNone;
        
        [self addSubview:_gridView];
        
        IGGridViewImageColumnDefinition* col = [[IGGridViewImageColumnDefinition alloc]initWithKey:@"imgUrl" forPropertyType:IGGridViewImageColumnDefinitionPropertyTypeURL];
        col.cacheImages = YES;
        
        _ds = [[IGGridViewSingleRowSingleFieldDataSourceHelper alloc]initWithField:col];
        _gridView.dataSource = _ds;
        
    }
    
    return self;
}

-(void)cellAttached
{
    _ds.data = self.data.media;
    [_gridView updateData];
    _gridView.contentOffset = CGPointMake(self.data.scrollPosition, 0);
}

-(void)cellDetached
{
    self.data.scrollPosition = _gridView.contentOffset.x;
    _ds.data = nil;
    [_ds invalidateData];
    [_gridView updateData];
    
    self.data = nil;
}

-(void)setupSize:(CGSize)size
{
    _gridView.frame = CGRectMake(0, 0, size.width, size.height);
}

@end
